	PROGRAM IMFMUS
C  Purpose:  Convert INTERMAGNET IMFV1.22 ASCII format (31-MAR-93),
C    to USGS standard binary 1-minute format.
C  Author:  L. Wilson, 6-APR-93
C  Limitations:
C    1).  The 2-character observatory identification code is obtained
C    from the input filename.  If the filename does not conform to the
C    USGS processing rules for naming files or if the filename does
C    not match the observatory data, the program will crash in OINFO or
C    produce erroneous 1-minute data.
C    2).  The IMFV1.22 data must have complete 60-minute data block
C    between headers.
C  Compiled:  C:\F77L\F77L and C:\F77L\VAXIBM libraties
C  Subroutines:
C  D:\GENERAL\GENERAL.LIB\GETFLN, UPPER, GYJD, OINFO, IDTBIN, WRITEDAY
C
	CHARACTER*1 TR
	CHARACTER*3 GIN
	CHARACTER*4 ORIEN
	CHARACTER*8 BEGDATE,ENDATE
	CHARACTER*10 T(3)
	CHARACTER*13 INF
	CHARACTER*26 APARM
	CHARACTER*31 INPATH,OUTFILE
	INTEGER*4 IV(2,4),IOERR,DECBAS
	INTEGER*2 IX(5762),E,I,J,GYJD,IB,IE,IYR,IHR,NPARM,IPARM(4),RND,
     *IDTBIN
	REAL*4 PYAM(4),VAL(4),FPARM(4),A,PYD
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
	DATA T/'Reported  ','Adjusted  ','Definitive'/
C
	OPEN(UNIT=*,CARRIAGE CONTROL='FORTRAN')
      WRITE(*,1000)
 1000 FORMAT('  Enter Input Filename> ')
	READ(*,1008)INPATH
 1008 FORMAT(A31)
	CALL UPPER(INPATH,30)
	CALL GETFLN(INPATH,INF,30)
	WRITE(*,1015)
 1015 FORMAT(1H&,' Enter beginning date to process [i.e. mm/dd/yy]> ')
	READ(*,1010)BEGDATE
	WRITE(*,1020)
 1020 FORMAT(1H&,' Enter ending date to process [ie. mm/dd/yy]> ')
	READ(*,1010)ENDATE
 1010 FORMAT(A)
	WRITE(*,1040)
 1040 FORMAT(1H&,' Enter output filename> ')
	READ(*,1010)OUTFILE
	CALL UPPER(OUTFILE,30)
	OPEN(UNIT=3,FILE=OUTFILE,FORM='UNFORMATTED',ERR=998,
     *STATUS='UNKNOWN',IOSTAT=IOERR,ACCESS='TRANSPARENT')
	IB=GYJD(BEGDATE)
	IE=GYJD(ENDATE)
	OPEN(UNIT=4,FILE=INPATH,FORM='FORMATTED',ERR=996,
     *STATUS='OLD',IOSTAT=IOERR,CARRIAGECONTROL='LIST')
   10 READ(4,1060,ERR=994)IYR,JD,IHR,ORIEN,TR,
     *GIN,DECBAS
 1060 FORMAT(9X,I2,1X,I3,1X,I2,1X,A4,1X,A1,1X,A3,10X,I6)
	IYJD=(IYR-70)*1000+JD
	IF(IYJD.LT.IB)GOTO 10
	WRITE(*,1009)ORIEN
 1009 FORMAT(1H&,' Orientation ',A4)
	IF(TR.EQ.'R')THEN
	  WRITE(*,1108)T(1)
 1108   FORMAT('  Data type: ',A)
	ELSE
	  IF(TR.EQ.'A')THEN
	    WRITE(*,1108)T(2)
	  ELSE
	    IF(TR.EQ.'D')WRITE(*,1108)T(3)
	  ENDIF
	ENDIF
	WRITE(*,1110)GIN
 1110 FORMAT('  Data from ',A3,/)
	PYD=0.1*FLOAT(DECBAS)
	IF(PYD.GT.10800.0)PYD=PYD-21600.
	CALL OINFO(1,INF(1:2),'PYAM:')
	DO I=1,4
	  PYAM(I)=FPARM(I)
	ENDDO
C      PRINT *,PYAM(2),PYD,DECBAS
	A=PYD-PYAM(2)
	I=RND(A)
	IF(I.GT.0)GOTO 970
	IX(5761)=IDTBIN(INF(1:2))
	IX(5762)=IYJD
   20 M=IHR*60+1
	DO J=1,30
	  READ(4,1070,ERR=994,END=980)(IV(1,E),E=1,4),(IV(2,E),E=1,4)
	  DO K=1,2
	    DO E=1,4
		IF(IV(K,E).EQ.999999)THEN
		  VAL(E)=32767.0
		ELSE
		  VAL(E)=0.1*FLOAT(IV(K,E))
		ENDIF
	    ENDDO
	    IF(ORIEN.EQ.'XYZF')THEN
		IF(VAL(1).NE.32767.0.AND.VAL(2).NE.32767.0)THEN
		  A=VAL(1)*VAL(1)+VAL(2)*VAL(2)
		  VAL(1)=SQRT(A)
		  A=VAL(2)/VAL(1)
		  D=ATAND(A)*60.0
		  VAL(2)=10.0*(D-PYAM(2))
		ELSE
		  VAL(1)=32767.0
		  VAL(2)=32767.0
		ENDIF
	    ENDIF
	    DO E=1,4
		IF(VAL(E).NE.32767.0)THEN
		  IF(E.EQ.2)THEN
		    VAL(E)=0.1*VAL(E)+PYD
		  ENDIF
		  A=VAL(E)-PYAM(E)
C              PRINT *,M,VAL(E),PYAM(E),A
		ELSE
		  A=32767.0
		ENDIF
		KK=(E-1)*1440 + M
		IF(A*10.0.LT.32767.0)THEN
		  A=A*10.0
		  IX(KK)=RND(A)
		ELSE
		  IX(KK)=32767
		ENDIF
	    ENDDO
	    M=M+1
	  ENDDO
	ENDDO
	IF(M.GE.1440)THEN
	  WRITE(3,ERR=994,IOSTAT=IOERR)IX
	  CALL WRITEDAY(IX(5762))
	  READ(4,1060,ERR=994,END=992)IYR,JD,IHR,ORIEN,TR,GIN,DECBAS
	  IYJD=(IYR-70)*1000+JD
	  IF((IYJD-1).NE.IX(5762))GOTO 990
	  IF(IYJD.GT.IE)GOTO 995
	  IX(5762)=IYJD
	  GOTO 20
	ELSE
	  READ(4,1060,ERR=994,END=980)IYR,JD,IHR,ORIEN,TR,GIN,DECBAS
	  IYJD=(IYR-70)*1000+JD
	  IF(IYJD.NE.IX(5762))GOTO 990
	  GOTO 20
	ENDIF
  970 PRINT *,'  DECBAS and PYAM(2) are not equal'
	GOTO 995
  980 WRITE(3,ERR=996,IOSTAT=IOERR)IX
	GOTO 992
  990 PRINT *,'  Days of year not consecutive'
	GOTO 995
  992 PRINT *,'  End Of File'
	GOTO 995
  994 WRITE(*,1080)MOD(IOERR,256),INPATH
  995 CLOSE(4)
	CLOSE(3)
	GOTO 999
  996 WRITE(*,1050)MOD(IOERR,256),OUTFILE
	GOTO 995
  998 WRITE(*,1050)MOD(IOERR,256),OUTFILE
  999 STOP
 1050 FORMAT(' ERROR ',I6,' OPENING FILE ',A)
 1070 FORMAT(3(I7,1X),I6,2X,3(I7,1X),I6)
 1080 FORMAT(' ERROR ',I6,1X,A)
	END
