	PROGRAM WDCUS
C
c  Purpose:  Convert data in WDC-A format to standard processing format
c            used by USGS/NGIC
c  Author:  N. Kleinkopf
C           L. Wilson 10/13/92, Modified for PC
c  Input:  - A one month (31 days) file of 1-minute data in the ASCII
c          WDC-A format contains 1190400 bytes.
c          - File 'OBSY.DAT' contains parameters used in conversion, must
C          be in current working directory.
c  Output:  A one month (31 days) binary file of 1-minute data in USGS/NGIC
c           processing format 357244 bytes.  Execution will overwrite files
c           with same file name.
c  Notes:  The source code was initially written in FORTRAN IV and FORTRAN 77
c          for use on a Digital Equipment MicroVax II computer.  The code
c          has been modified, compiled, and linked using Lahey F77L for
c          IBM compatible PCs using DOS.
C  Compiled:  C:\F77L\F77L and C:\F77L\VAXIBM libraries
c  Subroutines:  cvtch6, geomag, xythd
c  D:\GENERAL\GENERAL.LIB:  GYJD, IDTBIN, OINFO, WRITEDAY, UPPER, GETFLN
C
      CHARACTER*400 IY
      CHARACTER*80 PIY
	CHARACTER*30 INPATH,OUTF
	CHARACTER*26 APARM
	CHARACTER*13 INF
	CHARACTER*8 BYJD,IDATE
      CHARACTER*6 HOUR,CHIY
	CHARACTER*3 MO,DAY
	CHARACTER*2 YR,CRLF
	CHARACTER*1 ELEM,ZERO
	INTEGER*2 IX(5762),YJD,GYJD,IDN,IELEM,J,N,I,MIN,IHOUR,IPARM(4),
     2IDTBIN,SAVYJD,ISW,ISWEL,IB,IE,NPARM
	REAL*4 X(5760),PYAM(4),RHOUR,RX,FPARM(4)
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
	COMMON/CONVERT/IX,PYAM,X,CRLF
C
	OPEN(UNIT=*,CARRIAGE CONTROL='FORTRAN')
      ISWEL=0
      WRITE(*,1000)
 1000 FORMAT('  Enter WDC Filename> ')
	READ(*,1005)INPATH
 1005 FORMAT(A)
	CALL UPPER(INPATH,29)
	CALL GETFLN(INPATH,INF,29)
	WRITE(*,1018)
 1018 FORMAT(1H&,' Beginning Date of Input File [i.e., MM/DD/YY]> ')
	READ(*,1005)IDATE
	IB=GYJD(IDATE)
	WRITE(*,1019)
 1019 FORMAT(1H&,' Ending Date of Input File [i.e., MM/DD/YY]> ')
	READ(*,1005)IDATE
	IE=GYJD(IDATE)
	WRITE(*,1010)
 1010 FORMAT(1H&,' Enter Output NGIC Filename> ')
	READ(*,1005)OUTF
	CALL UPPER(OUTF,29)
	J=-1
	DO WHILE(J.NE.0)
	  WRITE(*,1008)
 1008   FORMAT(1H&,' Number of Bytes between Carriage Returns',/,
     *  '  Must be Modulo 80> ')
	  READ(*,*)ICR
	  J=MOD(ICR,80)
	ENDDO
      WRITE(*,1015)
 1015 FORMAT(1H&,' Do you want the zero values processed',
     *' as dead values ([Y]/N)? ')
	READ(*,1005)ZERO
	IF(ZERO.EQ.'y')ZERO='Y'
	CALL OINFO(1,INF(1:2),'PYAM:')   !Get PYAM from file OBSY.DAT
	DO I=1,4
	  PYAM(I)=FPARM(I)
	ENDDO
	WRITE(*,1017)(PYAM(I),I=1,4)
 1017 FORMAT(1H&,' PYAM(1-4) FOR THIS STATION ARE ',4F8.1//)
	OPEN(UNIT=1, FILE=INPATH, STATUS='OLD', FORM='UNFORMATTED',
     *ACCESS='TRANSPARENT',ERR=800,IOSTAT=IERR)
	OPEN(UNIT=2, FILE=OUTF, STATUS='UNKNOWN', FORM='UNFORMATTED',
     *ACCESS='TRANSPARENT',ERR=820,IOSTAT=IERR)
    5 J=1             !Read 400 character record to be converted to
	N=80            !1-hr of component values
	NCR=0
      DO I=1,5
	  READ(1,END=50,ERR=810,IOSTAT=IERR)PIY
	  IY(J:N)=PIY(1:80)
	  J=J+80
	  N=N+80
	  NCR=NCR+80
	  IF(NCR.GE.ICR)THEN
	    IF(ICR.NE.0)READ(1,ERR=810,IOSTAT=IERR)CRLF
	    NCR=0
	  ENDIF
	END DO
	IDN=IDTBIN(INF(1:2))     !Get observatory ID number from
					    !2 character observatory ID
      DO I=1,5760
       IX(I)=32767
       X(I)=32767.0
      END DO
   10 IF(IY(13:13) .EQ. '-')THEN  !Extract date from WDC header
        YR(1:1)='8'
	  YR(2:2)=INF(4:4)
      ELSE
        YR(1:2)=IY(13:14)
      ENDIF
      IF (IY(17:17) .EQ. ' ')THEN
        I=2
        DAY(1:2)=IY(18:18)//'/'
      ELSE
        I=3
        DAY(1:3)=IY(17:18)//'/'
      ENDIF
      IF (IY(15:15) .EQ. ' ')THEN
        N=2
        MO(1:2)=IY(16:16)//'/'
      ELSE
        N=3
        MO(1:3)=IY(15:16)//'/'
      ENDIF
	BYJD=MO(1:N)//DAY(1:I)// YR(1:2)
      ELEM=IY(19:19)
C
C  MAKE HOUR A 6-CHARACTER VARIABLE FOR CVTCH6
      HOUR='    '//IY(20:21)
	YJD=GYJD(BYJD)      !Convert ASCII date to binary coded date
	IF(YJD.LT.IB)GOTO 5     !Test interval to be converted
	IF(YJD.GT.IE)GOTO 50
      IF(SAVYJD .NE. 0)THEN
C
C** NEW DAY READ IN ?  ALWAYS SAVE THE PREVIOUS YEAR||JULIAN DAY
        IF(SAVYJD .LT. YJD)THEN
          ISW=1
	    GOTO 60
        ENDIF
      ENDIF
   30 SAVYJD=YJD
	IF(ELEM .EQ. 'F')THEN       !Get component and assign offset for
	  IELEM=4321                !coding
      ELSEIF (ELEM .EQ. 'X' .OR. ELEM .EQ. 'H')THEN
        IELEM=1
        IF(ELEM .EQ. 'X')ISWEL=1
      ELSEIF (ELEM .EQ. 'Y' .OR. ELEM .EQ. 'D')THEN 
        IELEM=1441
        IF(ELEM .EQ. 'Y')ISWEL=1
      ELSEIF (ELEM .EQ. 'Z')THEN
        IELEM=2881
      ENDIF
	RHOUR=CVTCH6(HOUR)      !Convert 60 ASCII values to binary values
	IHOUR=IFIX(RHOUR)       !beginning at MIN
      MIN=IHOUR*60
      J=35
      N=40
      DO I=1,60
	  CHIY=IY(J:N)
	  RX=CVTCH6(CHIY)
	  IF(RX .GT. 65000.0)RX=32767.0
	  IF(RX .EQ. 0.0 .AND. ZERO .EQ. 'Y')THEN
	    X(IELEM+MIN)=32767.0
	  ELSE
	    X(IELEM+MIN)=RX
	  ENDIF
	  J=J+6
	  N=N+6
	  MIN=MIN+1
      END DO
      J=1
      N=80
	NCR=0
	DO I=1,5
	  READ(1,END=50,ERR=810,IOSTAT=IERR)PIY
	  IY(J:N)=PIY(1:80)
	  J=J+80
	  N=N+80
	  NCR=NCR+80
	  IF(NCR.GE.ICR)THEN
	    IF(ICR.NE.0)READ(1,ERR=810,IOSTAT=IERR)CRLF
	    NCR=0
	  ENDIF
	END DO
      GOTO 10
   50 ISW=2
   60 IF(ISWEL .GT. 0)CALL XYTDH(X)
	CALL GEOMAG(ISWEL,INF(1:2))
      ISWEL=0
      IX(5761)=IDN
      IX(5762)=SAVYJD
	WRITE(2,ERR=830,IOSTAT=IERR)IX
      CALL WRITEDAY(SAVYJD)
	IF(ISW .EQ. 2)GOTO 811
      DO I=1,5760
       IX(I)=32767
       X(I)=32767.0
      END DO
	GOTO 30
  800 PRINT *,INPATH,' ERROR:',MOD(IERR,256)
	GOTO 999
  810 PRINT *,INPATH,' ERROR:',MOD(IERR,256)
  811 CLOSE(2)
  812 CLOSE(1)
	GOTO 999
  820 PRINT *,OUTF,' ERROR:',MOD(IERR,256)
	GOTO 812
  830 PRINT *,OUTF,' ERROR:',MOD(IERR,256)
	GOTO 811
 999  STOP
      END
