	SUBROUTINE OINFO(LUN,ID,PNAM)
C  OINFO retreives parameters from file OBSY.DAT, located in the current
C  working directory, reqested for an observatory identified by the
C  2-character identification code (ID), as specified by the ASCII string
C  PNAM.  The program has the following limitations:
C         1.  Parameter arrays must not exceed 4 elements
C         2.  Parameters must be separated by white space
C         3.  Parameter values must be INTEGER*2 or REAL*4
C
	CHARACTER*(*) PNAM
	CHARACTER*2 ID
	CHARACTER*26 APARM
	CHARACTER*72 LINE
	INTEGER*2 IPARM(4),NPARM,LASTCHR,LUN
	REAL*4 FPARM(4)
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
C
	OPEN(UNIT=LUN, FILE='OBSY.DAT', STATUS='OLD',
     * FORM='FORMATTED', CARRIAGECONTROL='LIST')
	DO I=1,4                !clear common parameters
	  FPARM(I)=0.0
	  IPARM(I)=0
	ENDDO
	NPARM=0
	DO I=1,26
	  APARM(I:I)=' '
	ENDDO
	I=1                     !search for 2-character ID
	DO WHILE(I.LT.32766)
	  READ(LUN,2000,END=888,ERR=777)LINE
 2000   FORMAT(A)
C        PRINT *, LINE
	  IF(ID.EQ.LINE(1:2))THEN
	    J=LASTCHR(LINE,26)          !found, search for parameter
	    APARM=LINE(3:J)
C          PRINT *,LINE
	    IF(PNAM.EQ.'FN')GOTO 999
	    J=INDEX(PNAM,':')
   10     READ(LUN,2000,END=888,ERR=777)LINE
	    K=INDEX(LINE,':')
	    IF(K.LT.1)GOTO 666
	    IF(J.NE.K)GOTO 10
	    IF(PNAM(1:J).NE.LINE(1:K))GOTO 10
	    M=KIND(LINE)                   !found parameter
	    IF(M.LT.0)GOTO 666              ! get type of parmeter
	    IF(M.EQ.0)CALL AGET(LINE)       ! get alphmeric string
	    IF(M.EQ.1)CALL IGET(LINE)       ! retreive integers values
	    IF(M.EQ.2)CALL FGET(LINE)       ! retreive real values
	    IF(NPARM.LT.0)GOTO 555
	    GOTO 999
	  ENDIF
	  I=I+1
	END DO
	STOP '  OINFO: Error in ID'
  555 STOP '  OINFO: Error Reading Parmameter Value'
  666 STOP '  OINFO: Could Not Find Parameter'
  777 STOP '  OINFO: Error Reading OBSY.DAT'
  888 STOP '  OINFO: EOF Reading OBSY.DAT'
  999 CLOSE(LUN)
	RETURN
	END
C----------------------------------------------------------------------
	FUNCTION LASTCHR(STRNG,J)             !Get index of the last non-
	CHARACTER*(*) STRNG                   ! blank character in STRNG
	INTEGER*2 J
	I=J
	DO WHILE(I.GT.0.AND.STRNG(I:I).EQ.' ')
	  I=I-1
	ENDDO
	LASTCHR=I
	RETURN
	END
C----------------------------------------------------------------------
	FUNCTION KIND(STRNG)                  !Identify the type of vari-
	CHARACTER*(*) STRNG                   ! ables as either alphameric,
	N=INDEX(STRNG,'.')                    ! integer or real.
	IF(N.GT.1)THEN
	  KIND=2
	  RETURN
	ENDIF
	N=INDEX(STRNG,':')
	IF(N.LT.1)THEN
	  KIND=-1
	  RETURN
	ENDIF
	N=N+1
	K=0
	DO WHILE(N.LE.72.AND.K.EQ.0)
	  IF(STRNG(N:N).EQ.' '.OR.STRNG(N:N).EQ.'-'
     *    .OR.STRNG(N:N).EQ.'+'.OR.(STRNG(N:N).GE.'0'
     *     .AND.STRNG(N:N).LE.'9'))THEN
	    N=N+1
	  ELSE
	    KIND=0
	    RETURN
	  ENDIF
	ENDDO
	KIND=1
	RETURN
	END
C----------------------------------------------------------------------
	SUBROUTINE FGET(STRNG)                !Parse ASCII string and
	CHARACTER*(*) STRNG                   ! convert to float.
	CHARACTER*26 APARM
	INTEGER*2 IPARM(4),NPARM,MINUS
	INTEGER*4 IVAL
	REAL*4 FPARM(4)
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
	MINUS=1                         !sign of value positive
	I=INDEX(STRNG,':')
	IF(I.LT.1)THEN
	  NPARM=-1
	  RETURN
	ENDIF
	NPARM=1
    5 IVAL=0
	NB=0
   10 I=I+1
	IF(I.GT.70) GOTO 888
	IF(STRNG(I:I).EQ.' ')THEN
	  NB=NB+1
	  IF(NB.LT.5)GOTO 10
	  NPARM=NPARM-1
	  GOTO 888
	ENDIF
	IF(STRNG(I:I).EQ.'-')THEN
	  MINUS=-1
	  GOTO 10
	ENDIF
	IF(STRNG(I:I).EQ.'+')GOTO 10
	IF(STRNG(I:I).GE.'0'.AND.STRNG(I:I).LE.'9')THEN
	  IVAL=IVAL*10
	  K=ICHAR(STRNG(I:I))-48
	  IVAL=IVAL+K
	  GOTO 10
	ENDIF
	IF(STRNG(I:I).NE.'.') GOTO 777
	IF(NPARM.GT.4) GOTO 777
	JVAL=0
	J=0
   20 I=I+1
	IF(STRNG(I:I).GE.'0'.AND.STRNG(I:I).LE.'9')THEN
	  JVAL=JVAL*10
	  K=ICHAR(STRNG(I:I))-48
	  JVAL=JVAL+K
	  J=J+1
	  GOTO 20
	ENDIF
	IF(STRNG(I:I).EQ.' ')THEN
	  KK=10**J
	  V=FLOAT(JVAL)/FLOAT(KK)
	  FPARM(NPARM)=(FLOAT(IVAL)+V)*FLOAT(MINUS)
	  MINUS=1
	  IF(NPARM.LT.4)THEN
	    NPARM=NPARM+1
	    GOTO 5
	  ELSE
	    GOTO 888
	  ENDIF
	ENDIF
  777 NPARM=-2
  888 RETURN
	END
C----------------------------------------------------------------------
	SUBROUTINE IGET(STRNG)                !Parse ASCII string and
	CHARACTER*(*) STRNG                   ! convert to integer.
	CHARACTER*26 APARM
	INTEGER*2 IPARM(4),NPARM,IVAL,MINUS
	REAL*4 FPARM(4)
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
	MINUS=1
	I=INDEX(STRNG,':')
	IF(I.LT.1)THEN
	  NPARM=-1
	  RETURN
	ENDIF
	NPARM=1
    5 IVAL=0
	NB=0
	IB=0
   10 I=I+1
	IF(I.GT.70) GOTO 888
	IF(STRNG(I:I).EQ.' '.AND.IB.EQ.0)THEN
	  NB=NB+1
	  IF(NB.LT.6)GOTO 10
	  NPARM=NPARM-1
	  GOTO 888
	ENDIF
	IF(STRNG(I:I).EQ.' '.AND.IB.EQ.1)THEN
	  IPARM(NPARM)=IVAL*MINUS
	  MINUS=1
	  IF(NPARM.GE.4)THEN
	    GOTO 888
	  ELSE
	    NPARM=NPARM+1
	    GOTO 5
	  ENDIF
	ENDIF
	IF(STRNG(I:I).EQ.'-')THEN
	  MINUS=-1
	  GOTO 10
	ENDIF
	IF(STRNG(I:I).EQ.'+')GOTO 10
	IF(STRNG(I:I).GE.'0'.AND.STRNG(I:I).LE.'9')THEN
	  IB=1
	  IVAL=IVAL*10
	  K=ICHAR(STRNG(I:I))-48
	  IVAL=IVAL+K
	  NB=0
	  GOTO 10
	ENDIF
  777 NPARM=-2
  888 RETURN
	END
C----------------------------------------------------------------------
	SUBROUTINE AGET(STRNG)                !Retreive substring following
	CHARACTER*(*) STRNG                   ! parameter name.
	CHARACTER*26 APARM
	INTEGER*2 IPARM(4),NPARM
	REAL*4 FPARM(4)
	COMMON/OBSYDAT/FPARM,IPARM,APARM,NPARM
	DO I=1,26
	  APARM(I:I)=' '
	ENDDO
	I=INDEX(STRNG,':')
	IF(I.LT.1)THEN
	  NPARM=-1
	  RETURN
	ENDIF
	I=I+1
	DO WHILE(STRNG(I:I).EQ.' ')
	  I=I+1
	ENDDO
	J=1
	DO WHILE(STRNG(I:I).NE.' ')
	  APARM(J:J)=STRNG(I:I)
	  I=I+1
	  J=J+1
	ENDDO
	NPARM=J-1
	RETURN
	END





